/**
 * @file
 * VuoList_VuoMidiController C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoMidiController_H
#define VuoList_VuoMidiController_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMidiController VuoList_VuoMidiController
 * A list of @ref VuoMidiController elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoMidiController
 * A list of @ref VuoMidiController elements.
 */
#ifndef VuoList_VuoMidiController_TYPE_DEFINED
typedef void * VuoList_VuoMidiController;
#endif

/**
 * Creates a new list of @ref VuoMidiController elements.
 */
VuoList_VuoMidiController VuoListCreate_VuoMidiController(void);

/**
 * Returns the @ref VuoMidiController at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMidiController VuoListGetValueAtIndex_VuoMidiController(const VuoList_VuoMidiController list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMidiController(VuoList_VuoMidiController list, const VuoMidiController value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMidiController(VuoList_VuoMidiController list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMidiController(VuoList_VuoMidiController list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMidiController(const VuoList_VuoMidiController list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMidiController VuoList_VuoMidiController_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMidiController_jsonFromValue(const VuoList_VuoMidiController value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMidiController_summaryFromValue(const VuoList_VuoMidiController value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMidiController VuoList_VuoMidiController_valueFromString(const char *str);
char * VuoList_VuoMidiController_stringFromValue(const VuoList_VuoMidiController value);
/// @}

/**
 * @}
 */

#endif
